#define _FILE_OFFSET_BITS 64
#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>

unsigned int records_to_create;
const unsigned int record_bytes = 100;
const unsigned int buffer_size = 400000;

void print_usage( const char* pname ){
	printf("Usage: %s <filename> <records> [append]\n");
}

int main(){
	int output_filedes;
	char* filename;
	unsigned int recordI, bufferI;
	int randomnum;
	char* write_buffer, *cur_buf_ptr;
	unsigned int byteI;
	char append = 0;
	
    if( argc != 3 && argc != 4){
    	if(argc == 1)
	    	print_usage( argv[0] );
	    else
	    	print_usage( "dmsortgen" );
	    exit( -1 );
    }
	
	filename = argv[1];
	records_to_create = atoi( argv[2] );
	if( argc == 4 )
		append = 1;
		
	srand(time(NULL));


	//overallocate slightly since the random filler code is sloppy.
	write_buffer = (char*)malloc(buffer_size * record_bytes + sizeof(randomnum));
	if(write_buffer == NULL){
		printf("Error allocating memory.\n");
		return -1;
	}

	if( append )
		output_filedes = open(filename, O_APPEND | O_WRONLY | O_LARGEFILE );
	else
		output_filedes = open(filename, O_CREAT | O_TRUNC | O_WRONLY | O_LARGEFILE, S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP);

	if(output_filedes < 0){
		perror("open file:");
		return -1;
	}

	bufferI = 0;
	cur_buf_ptr = write_buffer;
	for(recordI = 0; recordI < records_to_create; recordI++){
		if(bufferI == buffer_size){
			//perform a write
			write(output_filedes, write_buffer, buffer_size * record_bytes);
			bufferI = 0;
			cur_buf_ptr = write_buffer;
		}
		for(byteI = 0; byteI < record_bytes;){
			randomnum = rand();
			memcpy(cur_buf_ptr, &randomnum, sizeof(randomnum));
			cur_buf_ptr += sizeof(randomnum);
			byteI += sizeof(randomnum);
		}
		bufferI++;
	}

	//write the remaining records
	write(output_filedes, write_buffer, bufferI * record_bytes);
	bufferI = 0;
	cur_buf_ptr = write_buffer;
	fsync(output_filedes);
	close(output_filedes);
	return 0;
}


